//	IMAP protocol support script by 
//	ώRE]ڎR

class Imap
{
	var sock;
	var msg;
	var count;

	function Imap()
	{
		sock = new Socket();
		msg = "";
		count=1000;
	}

	function sendCommand(Msg)
	{
		temp=count+' '+Msg;
	//	Jupiter.print(temp);
		sock.sendCommand(temp);
		count++;
	}

	function readLine()
	{
		var temp;
		temp=sock.readLine();
	//	Jupiter.print(temp);
		return temp;
	}
	
	function connect(Server, Port)
	{
		if (!sock.connect(Server, Port))
		{
			return false;
		}

		msg = readLine().trim();
		if (msg.substr(0, 4) != "* OK")
		{
			sock.close();
			return false;
		}

		return true;
	}

	function quit()
	{
		if (!sock.connect(Server, Port))return;
		sendCommand('LOGOUT');
		sock.close();
	}

	function login(UserID, Password)
	{
		if (!sock.isConnected) return;

		sendCommand('CAPABILITY');
		msg = readLine();
		if (msg.substr(0, 1) != "*")
		{
			return false;
		}
		msg = readLine();
		if (msg.substr(5, 2) != "OK")
		{
			return false;
		}
		sendCommand('LOGIN ' + UserID + ' ' +Password);
		msg = readLine();
		
		if (msg.substr(5, 2) != "OK")
		{
			return false;
		}
		
		return true;
	}

	function uidl()
	{
		if (!sock.isConnected) return;

		result = new Array();
		sendCommand('SELECT "INBOX"');

		msg = readLine();
		while(msg.substr(0, 1) == "*"){
			if(msg.indexOf("EXISTS")>-1){
				n=msg.sliceString("* "," E");
			}
			msg = readLine();
		}
		if(n=="0"){
			return result;
		}
		sendCommand('FETCH 1:* UID');
		msg = readLine();
		while(msg.substr(0, 1) == "*"){
			result.concat(msg.sliceString("(UID ",")"));
			msg = readLine();
		}
		
		return result;
	}

	function retr(index)
	{
		list = "";

		if (!sock.isConnected) return "";

		//R}h𔭍s
		sendCommand('UID FETCH ' + index + " RFC822");

		//ŏ̍s擾
		temp = readLine();
		size=parseInt(temp.sliceString('{','}'));
	//	Jupiter.print("size"+size);
		var i;
		for(i=0;i<size;){
			ls=sock.readLine();
			list=list+ls;
			i=i+ls.length;
		}
		msg=readLine();
		while(1){
			if(msg.indexOf("OK")>-1)break;
			if(msg.indexOf("BAD")>-1)break;
			msg=readLine();
		}
		return list;
	}

	function dele(index)
	{
		if (!sock.isConnected) return false;

		//R}h𔭍s
		sendCommand('UID STORE ' + index +' +FLAGS (\\DELETED)');

		//擾
		msg = readLine();
		while(1){
			if(msg.indexOf("OK")>-1)break;
			if(msg.indexOf("BAD")>-1)break;
			msg=readLine();
		}
		return 1;
	}
	function expunge()
	{
		if (!sock.isConnected) return false;

		//R}h𔭍s
		sendCommand('expunge');

		//擾
		msg = readLine();
		while(1){
			if(msg.indexOf("OK")>-1)break;
			if(msg.indexOf("BAD")>-1)break;
			msg=readLine();
		}
		return true;
	}
}
